module FunctionImplementations.IO
  ( ListDirectory(..)
  , ReadTemplate(..)
  , ConvertImage(..)
  , SaveFile(..)
  , RunPandoc(..)
  ) where

import Sources()
import Types

data ListDirectory = ListDirectory deriving (Show)
instance IsFunctionIO ListDirectory FilePath [FilePath] where
  runFIO ListDirectory _path = undefined

data ReadTemplate = ReadTemplate deriving (Show)
instance IsFunctionIO ReadTemplate FilePath Template where
  runFIO ReadTemplate _path = undefined

data ConvertImage = ConvertImage deriving (Show)
instance IsFunctionIO ConvertImage ((FilePath, FilePath), ImageConversionSettings) () where
  runFIO ConvertImage ((_, _), ResizeToWidth _)  = undefined

data SaveFile = SaveFile deriving (Show)
instance IsFunctionIO SaveFile (String, FilePath) () where
  runFIO SaveFile _source = undefined

data RunPandoc = RunPandoc deriving (Show)
instance IsFunctionIO RunPandoc String String where
  runFIO RunPandoc _source = undefined
