{-# LANGUAGE FunctionalDependencies #-}
module Types where

import Data.ByteString (ByteString)

data ImageConversionSettings = ResizeToWidth Int
  deriving (Show)

data TemplatePart = Literal String
                  | KeyValue String
  deriving (Show)

data Template = Template [TemplatePart]
  deriving (Show)

class (SourceState a, Show f) => IsFunction f a b | f -> a b where
  runF :: f -> a -> b

class (SourceState a, Show f) => IsFunctionIO f a b | f -> a b where
  runFIO :: f -> a -> IO b

class SourceState a where
  stateOfSource :: a -> IO ByteString

